// InvStatInterface.cpp : implementation file
//

#include "stdafx.h"
#include "InvStat.h"
#include "InvStatInterface.h"
#include <time.h>

#include "warehouse.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// InvStatInterface

IMPLEMENT_DYNCREATE(InvStatInterface, CCmdTarget)


InvStatInterface::InvStatInterface()
{
	EnableAutomation();
}


InvStatInterface::~InvStatInterface()
{
}


void InvStatInterface::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}


BEGIN_MESSAGE_MAP(InvStatInterface, CCmdTarget)
	//{{AFX_MSG_MAP(InvStatInterface)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(InvStatInterface, CCmdTarget)
	//{{AFX_DISPATCH_MAP(InvStatInterface)
	DISP_FUNCTION(InvStatInterface, "StockStatus", StockStatus, VT_BSTR, VTS_BSTR)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IInvStatInterface to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {74FAE3D0-3A5B-11D2-9121-C61C8E63B54D}
static const IID IID_IInvStatInterface =
{ 0x74fae3d0, 0x3a5b, 0x11d2, { 0x91, 0x21, 0xc6, 0x1c, 0x8e, 0x63, 0xb5, 0x4d } };
IMPLEMENT_OLECREATE(InvStatInterface, "InvStat.Interface", 0x74fae3d0, 0x3a5b, 0x11d2, 0x91, 0x21, 0xc6, 0x1c, 0x8e, 0x63, 0xb5, 0x4d);

BEGIN_INTERFACE_MAP(InvStatInterface, CCmdTarget)
	INTERFACE_PART(InvStatInterface, IID_IInvStatInterface, Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// InvStatInterface message handlers

BSTR InvStatInterface::StockStatus(LPCTSTR productSKU) 
{
	CString strResult;
	CString reorderMsg = " ";
	char	*sku;
	char	*mfgID;
	int		quantity;

	try {

		Warehouse* checkWareh = new Warehouse();
		quantity = checkWareh->StockUpdate(productSKU);
		sku = checkWareh->GetSKU();
		mfgID = checkWareh->GetMfgID();
		delete checkWareh;
//		checkWareh = 0;
		if	(quantity == 0)  
		{
			reorderMsg = StockReorder(mfgID,sku);
			strResult.Format("Onhand stock for CD with UPC - %s - is - %i units\n%s",sku,quantity,reorderMsg);
		}
		else
		{
			// Check re-order threshold and append any warnings required.
			reorderMsg = checkWareh->ThresholdCheck(sku,quantity);
			strResult.Format("Onhand stock for CD with UPC - %s - is - %i units\n%s",sku, quantity,reorderMsg);

		}
			
	}

	catch (...) {
		// do nothing
	}
	return strResult.AllocSysString();
}

BSTR InvStatInterface::StockReorder(LPCTSTR sku,LPCTSTR mfgID) 
{
		CString strResult;
		Warehouse* checkWareh = new Warehouse();
		strResult = checkWareh->StockReorder(sku,mfgID);
		delete checkWareh;
		return strResult.AllocSysString();
}

