VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ShoppingCartModifier"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3841B03203BF"
Attribute VB_Ext_KEY = "RVB_ModelStereotype" ,"Data Modifier"
Option Explicit

'##ModelId=384DAC110367
Private RequiresTransaction As Boolean

'##ModelId=384DB5EB0331
'Private objCTX As ObjectContext

'##ModelId=384DB6000332
Private blnInMTS As Boolean

Public Function addToCart(cdID As Integer, orderID As Integer) As Integer
    On Error GoTo addToCartErr
    
        Dim currentConnection As ADODB.Connection
        Set currentConnection = CreateObject("ADODB.Connection")
        currentConnection.connectionString = connectionString
        Call currentConnection.Open
        
        Dim sqlCommand As ADODB.Command
        Set sqlCommand = CreateObject("ADODB.Command")
        With sqlCommand
            .ActiveConnection = currentConnection
            .CommandText = "getOrderItems"
            .CommandType = adCmdStoredProc
            .CommandTimeout = 15
            
            Dim sqlParameter As ADODB.Parameter
            Set sqlParameter = sqlCommand.CreateParameter("orderID", adInteger, adParamInput, , orderID)
            .Parameters.Append sqlParameter
            Dim orderItems As ADODB.Recordset
            Set orderItems = CreateObject("ADODB.Recordset")
            orderItems.ActiveConnection = currentConnection
            orderItems.CursorType = adOpenKeyset
            orderItems.LockType = adLockOptimistic
            orderItems.Open sqlCommand
        End With
        
        If orderItems.BOF And orderItems.EOF Then
            addToCart = createNewOrder
        Else
            addToCart = orderID
        End If
        
        Do Until orderItems.EOF
            If orderItems("CD_ID") = cdID Then
                orderItems("QUANTITY") = CInt(orderItems("QUANTITY")) + 1
                orderItems.Update
                Exit Function
            End If
            orderItems.MoveNext
        Loop
        
        orderItems.AddNew
        orderItems("ORDER_ID") = addToCart
        orderItems("CD_ID") = cdID
        orderItems("QUANTITY") = 1
        orderItems.Update

    Exit Function
addToCartErr:
    Call RaiseError(MyUnhandledError, "addToCart Function")
End Function

'##ModelId=38A0560C0346
Public Sub removeFromCart(cdID As Integer, orderID As Integer)
    On Error GoTo removeFromCartErr
        Dim UniqueTable As String
        Dim currentConnection As ADODB.Connection
        Set currentConnection = CreateObject("ADODB.Connection")
        currentConnection.connectionString = connectionString
        Call currentConnection.Open
        
        Dim sqlCommand As ADODB.Command
        Set sqlCommand = CreateObject("ADODB.Command")
        With sqlCommand
            .ActiveConnection = currentConnection
            .CommandText = "getOrderItems"
            .CommandType = adCmdStoredProc
            .CommandTimeout = 15
            
            Dim sqlParameter As ADODB.Parameter
            Set sqlParameter = sqlCommand.CreateParameter("orderID", adInteger, adParamInput, , orderID)
            .Parameters.Append sqlParameter
            Dim orderItems As ADODB.Recordset
            Set orderItems = CreateObject("ADODB.Recordset")
            orderItems.ActiveConnection = currentConnection
            orderItems.CursorLocation = adUseClient
            orderItems.CursorType = adOpenStatic
            orderItems.LockType = adLockBatchOptimistic
            UniqueTable = orderItems.Properties("Unique Table")
            orderItems.Open sqlCommand
        End With
        
        Do Until orderItems.EOF
            If orderItems("CD_ID") = cdID Then
                If orderItems("QUANTITY") = 1 Then
                    orderItems.Delete adAffectCurrent
                    'orderItems.Open "SELECT * FROM ORDER_ITEM " & "WHERE QUANTITY <> 1", currentConnection, , , adCmdText
                    
                    orderItems.UpdateBatch
                Else
                orderItems("QUANTITY") = CInt(orderItems("QUANTITY")) - 1
                orderItems.UpdateBatch
                End If
                
                Exit Sub
            End If
            orderItems.MoveNext
        Loop

    Exit Sub
removeFromCartErr:
    Call RaiseError(MyUnhandledError, "removeFromCart Sub")
End Sub

Private Function createNewOrder() As Integer
    On Error GoTo createNewOrderErr
    
        Dim currentConnection As ADODB.Connection
        Set currentConnection = CreateObject("ADODB.Connection")
        currentConnection.connectionString = connectionString
        Call currentConnection.Open
        
        Dim sqlCommand As ADODB.Command
        Set sqlCommand = CreateObject("ADODB.Command")
        With sqlCommand
            .ActiveConnection = currentConnection
            .CommandText = "getOrders"
            .CommandType = adCmdStoredProc
            .CommandTimeout = 15
            
            Dim sqlParameter As ADODB.Parameter
            Set sqlParameter = sqlCommand.CreateParameter("orderID", adInteger, adParamInput, , 0)
            .Parameters.Append sqlParameter
            Dim orders As ADODB.Recordset
            Set orders = CreateObject("ADODB.Recordset")
            orders.ActiveConnection = currentConnection
            orders.CursorType = adOpenKeyset
            orders.LockType = adLockOptimistic
            orders.Open sqlCommand
        End With
        
        orders.AddNew
        orders("CUSTOMER_ID") = 1
        orders("STATE") = 0
        orders.Update
        
        createNewOrder = orders("ID")

    Exit Function
createNewOrderErr:
    Call RaiseError(MyUnhandledError, "createNewOrder Function")
End Function

'##ModelId=384D96960017
'##Public Sub delete(intID As Integer)
   '## On Error GoTo deleteErr

    '## Your code goes here ...

    '##Exit Sub
'##deleteErr:
    '##Call RaiseError(MyUnhandledError, "delete Sub")
'##End Sub

'##ModelId=384D96B701B9
Public Sub save(rs As Recordset)
    On Error GoTo saveErr

    '## Your code goes here ...

    Exit Sub
saveErr:
    Call RaiseError(MyUnhandledError, "save Sub")
End Sub

'##ModelId=384D9D5302FC
Public Function getNewID(strTable As String) As Integer
    On Error GoTo getNewIDErr

    '## Your code goes here ...

    Exit Function
getNewIDErr:
    Call RaiseError(MyUnhandledError, "getNewID Function")
End Function

'MTS object can be pooled
'##ModelId=384DA3CE03AC
Public Function objCtrl_CanBePooled() As Boolean
    On Error GoTo objCtrl_CanBePooledErr

    '## Your code goes here ...

    Exit Function
objCtrl_CanBePooledErr:
    Call RaiseError(MyUnhandledError, "objCtrl_CanBePooled Function")
End Function

'##ModelId=384DA3E502B5
Public Sub objCtrl_Activate()
    On Error GoTo objCtrl_ActivateErr

    '## Your code goes here ...

    Exit Sub
objCtrl_ActivateErr:
    Call RaiseError(MyUnhandledError, "objCtrl_Activate Sub")
End Sub

'##ModelId=384DA3EF0327
Public Sub objCtrl_Deactivate()
    On Error GoTo objCtrl_DeactivateErr

    '## Your code goes here ...

    Exit Sub
objCtrl_DeactivateErr:
    Call RaiseError(MyUnhandledError, "objCtrl_Deactivate Sub")
End Sub
