@REM Batch file to deploy the RQA generated stub

@REM Brian Bryson, BBryson@Rational.Com
@REM Vancouver, BC, Canada
@REM Original   : 07-May-01, Rainier, v2001A
@REM Updated	: 25-Sep-01, Olympus Mons, v2002
@REM Last Update: 17-Jan-03, McKinley, v2003


@Echo Off

	CLS
	REM Setup classpath and environment variables
	CALL UTL_SetEnv.BAT

@Echo On



@Echo Off

	REM To hot deploy, delete old JAR file, wait 5 seconds, copy in new JAR file
	Echo Deploying RQA generated stub...
	
	REM Delete current
	DEL "%WL_HOME%"\user_projects\ClassicsJ2EE\applications\ejb_classics.jar >NUL
	
	REM Wait 5 seconds
	TYPE NUL | "C:\Classics\RQA Tests\RQA WebLogic Assets\Source\CHOICE.COM" /N /CY /TY,5 >NUL

	REM Copy in new JAR
	COPY Backup\Stub\ejb_classics.jar "%WL_HOME%"\user_projects\ClassicsJ2EE\applications\.  > DeployResult.txt
	
	REM Error check
	type DeployResult.txt | find /c /i "0 file(s) copied" > nul
	if errorlevel 1 goto NoDeploymentErrorsFound
	if errorlevel 0 goto DeploymentErrorsFound

	:DeploymentErrorsFound
	Echo Some server files are still in use and locked.  Please shut down all access 
	Echo to the server and re-run the deployment batch file.
	goto End

	:NoDeploymentErrorsFound
	Echo Deployment successful.
	del DeployResult.txt


@Echo On

:End

