package com.rational.cdshop.ejb;

import java.rmi.RemoteException;
// import java.security.Identity;
import java.util.Properties;
import javax.ejb.*;

import java.util.Vector;
import javax.naming.*;

import com.rational.cdshop.ejb.*;

/**
 * This is a Session Bean Class
 */
public class ShoppingCartBean implements SessionBean {
	private javax.ejb.SessionContext mySessionCtx = null;
	final static long serialVersionUID = 3206093459760846163L;
	Vector items = new Vector();
	private int count = 0;
	
public int getCount() throws java.rmi.RemoteException {
	return count;
}

public void incCount() throws java.rmi.RemoteException {
	count = count + 1;
}

public boolean addItem(Cd cd) throws java.rmi.RemoteException {

	items.addElement(cd);
	return true;
	
}
public double calculateSubTotal() throws java.rmi.RemoteException {

	double total = 0;
	java.util.Enumeration enum = items.elements();
	while (enum.hasMoreElements()) {
		Cd tmpCd = (Cd) enum.nextElement();
		total += tmpCd.getPrice();
	}
	
	return total;
	
}
public double calculateTax() throws java.rmi.RemoteException {

	try {

		double totalTax = 0.0;
		java.util.Enumeration enum = items.elements();
		while (enum.hasMoreElements()) {
			Cd cd = (Cd) enum.nextElement();
			int taxCode = cd.getTax_code();
			double price = cd.getPrice();

			javax.naming.Context ctx = getInitialContext();
			TaxHome home = (TaxHome) ctx.lookup("Tax");
			Tax tax = (com.rational.cdshop.ejb.Tax) javax.rmi.PortableRemoteObject.narrow(home.findByCode(taxCode), com.rational.cdshop.ejb.Tax.class);
			double rate = tax.getRate();

			totalTax = totalTax + price * rate;
		}

		return totalTax;
			
		
	} catch (NamingException ne) {
		System.out.println(ne.getLocalizedMessage());
		ne.printStackTrace();
	} catch (FinderException fe) {
		System.out.println(fe.getLocalizedMessage());
		fe.printStackTrace();
	}

	
	return 0.0;
}
public double calculateTotal() throws java.rmi.RemoteException {

	return calculateTax() + calculateSubTotal();
	
}
public int countItems() throws java.rmi.RemoteException {
	return items.size();
}
/**
 * ejbActivate method comment
 * @exception java.rmi.RemoteException The exception description.
 */
public void ejbActivate() throws java.rmi.RemoteException {}
/**
 * ejbCreate method comment
 * @exception javax.ejb.CreateException The exception description.
 * @exception java.rmi.RemoteException The exception description.
 */
public void ejbCreate() throws javax.ejb.CreateException, java.rmi.RemoteException {}
/**
 * ejbPassivate method comment
 * @exception java.rmi.RemoteException The exception description.
 */
public void ejbPassivate() throws java.rmi.RemoteException {}
/**
 * ejbRemove method comment
 * @exception java.rmi.RemoteException The exception description.
 */
public void ejbRemove() throws java.rmi.RemoteException {}
/**
 * Insert the method's description here.
 * Creation date: (3/1/2001 2:11:56 AM)
 */
public void emptyCart() throws RemoteException {

	items.removeAllElements();
		
}
private Context getInitialContext() throws NamingException {
	
	Properties p = new Properties();

	p.setProperty(Context.PROVIDER_URL,"t3://localhost:7001/");
	p.setProperty(Context.INITIAL_CONTEXT_FACTORY,"weblogic.jndi.WLInitialContextFactory");
		
	return new InitialContext(p);
}

/**
 * getSessionContext method comment
 * @return javax.ejb.SessionContext
 */
public javax.ejb.SessionContext getSessionContext() {
	return mySessionCtx;
}
public Cd[] listItems() throws java.rmi.RemoteException {

	Cd[] cds = new Cd[items.size()];
	java.util.Enumeration enum = items.elements();
	int count = 0;
	while (enum.hasMoreElements()) {
		cds[count] = (Cd) enum.nextElement();
		count ++;
	}
	
	return cds;

}
public boolean removeItem(String upc) throws java.rmi.RemoteException {

	java.util.Enumeration enum = items.elements();
	while (enum.hasMoreElements()) {
		Cd tmpCd= (Cd) enum.nextElement();
		if (tmpCd.getUpc().equals(upc)) {
			items.removeElement(tmpCd);
			//return true;
		}
		//else return false;
	}

	
	try {

		int orderId = 1145;
		int quantity = 0;
		Context ctx = getInitialContext();

		CdHome home = (CdHome) ctx.lookup("Cd");
		Cd cd = (Cd) javax.rmi.PortableRemoteObject.narrow(home.findByUPC(upc), com.rational.cdshop.ejb.Cd.class);
		items.addElement(cd);
		
		Order_ItemHome oihome = (Order_ItemHome) ctx.lookup("Order_Item");
		Order_Item orderItem = (Order_Item) javax.rmi.PortableRemoteObject.narrow(oihome.findByOrderIdAndUPC(orderId, upc), com.rational.cdshop.ejb.Order_Item.class);


		quantity = orderItem.getQuantity();
		
		if (quantity > 1 )
			orderItem.setQuantity(quantity-1);
		else
			orderItem.setQuantity(0);
			
	} catch (NamingException ne) {
		System.out.println(ne.getLocalizedMessage());
		ne.printStackTrace();
	} catch (RemoteException re) {
		System.out.println(re.getLocalizedMessage());
		re.printStackTrace();
	} catch (FinderException fe) {
		System.out.println(fe.getLocalizedMessage());
		fe.printStackTrace();
	}

	return true;	
}
/**
 * setSessionContext method comment
 * @param ctx javax.ejb.SessionContext
 * @exception java.rmi.RemoteException The exception description.
 */
public void setSessionContext(javax.ejb.SessionContext ctx) throws java.rmi.RemoteException {
	mySessionCtx = ctx;
}


public boolean setQuantity(int orderId, java.lang.String upc, int quantity) throws java.rmi.RemoteException { 

	boolean result = false;

	try {
		Context ctx = getInitialContext();
		Order_ItemHome home = (Order_ItemHome) ctx.lookup("Order_Item");
		Order_Item orderItem = (Order_Item) javax.rmi.PortableRemoteObject.narrow(home.findByOrderIdAndUPC(orderId, upc), com.rational.cdshop.ejb.Order_Item.class);

		orderItem.setQuantity(quantity);

		result = true;
		
	} catch (NamingException ne) {
		System.out.println(ne.getLocalizedMessage());
		ne.printStackTrace();
		result = false;
	} catch (FinderException fe) {
		System.out.println(fe.getLocalizedMessage());
		fe.printStackTrace();
		result = false;
	}
	
	return result; 
}
public boolean addItem(int orderId, java.lang.String upc) throws java.rmi.RemoteException {

	try {

		int quantity = 0;
		Context ctx = getInitialContext();

		CdHome home = (CdHome) ctx.lookup("Cd");
		Cd cd = (Cd) javax.rmi.PortableRemoteObject.narrow(home.findByUPC(upc), com.rational.cdshop.ejb.Cd.class);
		items.addElement(cd);
		
		Order_ItemHome oihome = (Order_ItemHome) ctx.lookup("Order_Item");
		Order_Item orderItem = (Order_Item) javax.rmi.PortableRemoteObject.narrow(oihome.findByOrderIdAndUPC(orderId, upc), com.rational.cdshop.ejb.Order_Item.class);


		quantity = orderItem.getQuantity();	
		orderItem.setQuantity(quantity+1);
		
			
	} catch (NamingException ne) {
		System.out.println(ne.getLocalizedMessage());
		ne.printStackTrace();
	} catch (RemoteException re) {
		System.out.println(re.getLocalizedMessage());
		re.printStackTrace();
	} catch (FinderException fe) {
		System.out.println(fe.getLocalizedMessage());
		fe.printStackTrace();
	}
		return true;
		
	
}public boolean removeItem(int orderId, java.lang.String upc) throws java.rmi.RemoteException {

	java.util.Enumeration enum = items.elements();
	while (enum.hasMoreElements()) {
		Cd tmpCd= (Cd) enum.nextElement();
		if (tmpCd.getUpc().equals(upc)) {
			items.removeElement(tmpCd);
		}
		
	}

	
	try {

		int quantity = 0;
		Context ctx = getInitialContext();

		CdHome home = (CdHome) ctx.lookup("Cd");
		Cd cd = (Cd) javax.rmi.PortableRemoteObject.narrow(home.findByUPC(upc), com.rational.cdshop.ejb.Cd.class);
		items.addElement(cd);
		
		Order_ItemHome oihome = (Order_ItemHome) ctx.lookup("Order_Item");
		Order_Item orderItem = (Order_Item) javax.rmi.PortableRemoteObject.narrow(oihome.findByOrderIdAndUPC(orderId, upc), com.rational.cdshop.ejb.Order_Item.class);


		quantity = orderItem.getQuantity();
		
		if (quantity > 1 )
			orderItem.setQuantity(quantity-1);
		else
			orderItem.setQuantity(0);
			
	} catch (NamingException ne) {
		System.out.println(ne.getLocalizedMessage());
		ne.printStackTrace();
	} catch (RemoteException re) {
		System.out.println(re.getLocalizedMessage());
		re.printStackTrace();
	} catch (FinderException fe) {
		System.out.println(fe.getLocalizedMessage());
		fe.printStackTrace();
	}

	return true;	
}}
